﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Services.Optimization.ControllerService.Model;

namespace HeuristicLab.Services.Optimization.ControllerService.Interfaces {
  public interface IScenarioManager {
    string DispatchScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);
    IList<Job> GetJobs(User user);
    Job GetJob(User user, string id);
    bool DeleteJob(User user, string id);
    IList<Model.Run> GetJobResults(User user, string id);
    bool AddScenario(User user, string scenarioName, string scenarioXml, string scenarioMapper);
    bool DeleteScenario(User user, string scenarioName);

    bool SaveExperiment(User user, Experiment experiment);
    IEnumerable<string> GetExperiments(User user);
    bool DeleteExperiment(User user, string experiment);

    Task GetTaskData(User u, string jobId, string taskId);
    Job GetTasks(User u, string jobId);

    Experiment GetExperimentByName(User user, string scenario);
    bool DispatchExperiment(User user, Experiment exp, JobExecutionDetails details);
  }
}
